<template>
  <div itemscope itemtype="http://schema.org/Book">
    <Ariane
      v-if="publisher"
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />

    <div class="trunk content">
      <link
        itemprop="additionalType"
        href="http://schema.org/PublicationVolume"
      /><!-- /if is part of a serie -->
      <link itemprop="additionalType" href="http://schema.org/Product" />
      <link itemprop="bookFormat" href="http://schema.org/Ebook" />

      <Loader :display="isLoading" />
      <ContainerHeader :info="headerData" />
      <div class="list block">
        <header class="block-header">
          <h2 class="block-title">
            {{ $t('publisher.seriesListHeader') }}.
            <span>{{
              $tc('common.nbSeries', serieCount, { count: serieCount })
            }}</span>
          </h2>
        </header>
        <template v-if="displayedList.length">
          <div class="products-list series-list products-list--grid trunk">
            <SmallSerie
              v-for="serie of displayedList"
              :key="serie.id"
              :serie="serie"
              :is-subscription="false"
              :for-search="true"
            />
            <EmptySerie v-for="empty of emptySeries" :key="empty" />
          </div>

          <Loader :display="isLoadingPage" />
          <Pagination
            v-if="serieCount > paginationLimit"
            :current-page="currentPage"
            :total-page="totalPage"
            :items-per-page="paginationLimit"
            @updatePage="updatePage"
          />
        </template>
      </div>
    </div>
  </div>
</template>

<script>
import Ariane from '~/components/ui/Ariane'
import ContainerHeader from '~/components/ContainerHeader'
import SmallSerie from '~/components/SmallSerie'
import EmptySerie from '~/components/Empty/EmptySerie'
import Pagination from '~/components/ui/Pagination'
import Loader from '~/components/ui/Loader'

export default {
  name: 'PublisherPage',
  components: {
    Ariane,
    ContainerHeader,
    SmallSerie,
    EmptySerie,
    Pagination,
    Loader
  },

  async fetch() {
    await this.loadPublisher()
  },

  data() {
    return {
      isLoading: false,
      isLoadingPage: false,
      breadcrumbs: [
        this.$t('breadcrumb.home'),
        this.$t('breadcrumb.publishers')
      ],
      params: [`/${this.$i18n.locale}/`, this.localePath('publishers')],
      publisher: false,
      currentPage: 1,
      paginationLimit: 18,
      totalPage: undefined,
      displayedList: []
    }
  },

  computed: {
    title() {
      return `${this.publisher.name} - ${this.$t('author.allAuthorAlbums')}`
    },
    serieCount() {
      return this.publisher && this.publisher.series
        ? this.publisher.series.count
        : 0
    },
    emptySeries() {
      const array = []

      if (this.displayedList.length) {
        for (let i = this.displayedList.length % 6; i < 6; i++) {
          array.push(i)
        }
      }

      return array
    },
    headerData() {
      let d = { name: '', title: '', imageUrl: '', description: '' }
      if (this.publisher) {
        d = {
          name: this.publisher.name,
          title: '',
          imageUrl: `${this.$axios.defaults.baseURL}/${this.$i18n.locale}/images/publisher/${this.publisher.id}.jpg`,
          description: this.publisher.resume
        }
      }
      return d
    }
  },

  methods: {
    async loadPublisher() {
      this.isLoading = true
      try {
        const id = this.$api.extractIdFromSlugId(this.$route.params.id).id

        const data = await this.$api.publisher(id)
        if (!data) return

        this.publisher = data

        this.breadcrumbs.push(this.publisher.name)
        this.params.push({
          name: 'publisher',
          slug: this.publisher.slug,
          id: this.publisher.id
        })

        this.totalPage = Math.ceil(
          this.publisher.series.count / this.paginationLimit
        )

        this.publisher.series.pages = [this.publisher.series.series]

        await this.setDisplayed()
      } finally {
        this.isLoading = false
      }
    },

    async loadPage(page) {
      if (this.publisher && this.publisher.series.count) {
        this.isLoadingPage = true
        try {
          const offset = (page - 1) * this.paginationLimit

          const data = await this.$api.publisherSeries(
            this.publisher.id,
            offset
          )
          if (!data) return

          this.publisher.series.pages[page - 1] = data.series
        } finally {
          this.isLoadingPage = false
        }
      }
    },

    updatePage(currentPage) {
      this.currentPage = currentPage

      this.setDisplayed()
    },

    async setDisplayed() {
      if (this.publisher && this.publisher.series.count) {
        if (!this.publisher.series.pages[this.currentPage - 1])
          await this.loadPage(this.currentPage)

        this.displayedList = this.publisher.series.pages[this.currentPage - 1]
      }
    }
  },

  head() {
    return {
      titleTemplate: this.title
    }
  }
}
</script>

<style lang="scss" scoped>
.content {
  margin-top: 100px;
}

.list {
  margin-top: 30px;
}

.block-title {
  display: block;
  line-height: 1.39;
  float: left;
  margin: 0 0 15px;
  font-family: DINCond-Regular, sans-serif;
  font-size: 2.57143rem;
  font-weight: 400;
  text-transform: uppercase;

  span {
    color: #ff641e;
    text-transform: none;
    display: inline;
  }
}
</style>
